???File Path
==========
***...\Models\accounts\PackageModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@  PackageMaster  @@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlPackageMaster : MdlUserAction {

	public long binPackageMasterId { get; set; } = 0;
	
	[Required()]
	[Display(Name = "Package Category")]
	public long binPackageCategoryId { get; set; } = 0;
	public long? binIncomeAcId { get; set; } = null;
	public long? binControlAcId { get; set; } = null;
	
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(250)]
	[Display(Name = "Package Code")]
	public string strPackageCode { get; set; } = "";
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(250)]
	[Display(Name = "Package Name")]
	public string strPackageName { get; set; } = "";
	public short sinDefault { get; set; } = 0;
	public short sinOwnPackage { get; set; } = 0;
	[StringLength(15)]
	public string strErpCode { get; set; } = "";
	
	[DataType(DataType.Date)]
	[Display(Name = "Issue From")]
	public DateTime datIssueFrom { get; set; } = null;
	[DataType(DataType.Date)]
	[Display(Name = "Issue To")]
	public DateTime datIssueTo { get; set; } = null;
	[DataType(DataType.Date)]
	[Display(Name = "Service From")]
	public DateTime datServiceFrom { get; set; } = null;
	[DataType(DataType.Date)]
	[Display(Name = "Service To")]
	public DateTime datServiceTo { get; set; } = null;
	
	public short sinAllowStock { get; set; } = 1;
	public short sinNoOfDays { get; set; } = 1;
	public short sinNoOfPax { get; set; } = 1;
	public short sinAdult { get; set; } = 1;
	public short sinChild { get; set; } = 0;
	public short sinInfant { get; set; } = 0;
	
	public long[] arlFkBranchIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkBranchIds { get; set; } = "";
	public long[] arlFkServiceIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkServiceIds { get; set; } = "";
	
	public string strRemarks { get; set; } = "";
	
	public short sinAdditionalItemInInvoicePrint { get; set; } = 1;
	public short sinAdditionalItemDetailsInFileOpenPrint { get; set; } = 1;
	public short sinPrintInformationInInvoicePrint { get; set; } = 1;
	public short sinPrintInformationDetailsInFileOpenPrint { get; set; } = 1;
	
	public long? binSupplierAcId { get; set; } = null;
	public long? binSupplierSideControlAcId { get; set; } = null;
	public long? binCommissionAcId { get; set; } = null;
	public long? binServiceFeeAcId { get; set; } = null;
	public long? binManagementFeeAcId { get; set; } = null;
	public long? binPaybackAcId { get; set; } = null;
	public long? binDiscountAcId { get; set; } = null;
	
	[StringLength(3)]
	public string strBaseCurrency { get; set; } = "";
	public double dblBaseCurFare { get; set; } = 0.0;
	public double dblBaseCurTax { get; set; } = 0.0;
	public double dblBaseCurCommPercentage { get; set; } = 0.0;
	public double dblBaseCurCommissionAmount { get; set; } = 0.0;
	public double dblBaseCurSupplierFeePerc { get; set; } = 0.0;
	public double dblBaseCurSupplierFee { get; set; } = 0.0;
	public double dblBaseCurSupplierAmount { get; set; } = 0.0;
	public double dblBaseCurServiceFeePerc { get; set; } = 0.0;
	public double dblBaseCurServiceFee { get; set; } = 0.0;
	public double dblBaseCurManagementFeePerc { get; set; } = 0.0;
	public double dblBaseCurManagementFee { get; set; } = 0.0;
	public double dblBaseCurDiscountPerc { get; set; } = 0.0;
	public double dblBaseCurDiscount { get; set; } = 0.0;
	public double dblBaseCurCost { get; set; } = 0.0;
	public double dblBaseCurPrice { get; set; } = 0.0;
	
	[StringLength(3)]
	public string strSupCurrency { get; set; } = "";
	public double dblSupCurRoe { get; set; } = 1.00;
	public double dblSupCurFare { get; set; } = 0.0;
	public double dblSupCurTax { get; set; } = 0.0;
	public double dblSupCurCommPercentage { get; set; } = 0.0;
	public double dblSupCurCommissionAmount { get; set; } = 0.0;
	public double dblSupCurSupplierFeePerc { get; set; } = 0.0;
	public double dblSupCurSupplierFee { get; set; } = 0.0;
	public double dblSupCurSupplierAmount { get; set; } = 0.0;
	public double dblSupCurServiceFeePerc { get; set; } = 0.0;
	public double dblSupCurServiceFee { get; set; } = 0.0;
	public double dblSupCurManagementFeePerc { get; set; } = 0.0;
	public double dblSupCurManagementFee { get; set; } = 0.0;
	public double dblSupCurDiscountPerc { get; set; } = 0.0;
	public double dblSupCurDiscount { get; set; } = 0.0;
	public double dblSupCurCost { get; set; } = 0.0;
	public double dblSupCurPrice { get; set; } = 0.0;
	
	public string jsnBatchDetails { get; set; } = "[]";
	
	public short sinRecordStatus { get; set; } = 1;
	public short sinOrder { get; set; } = 1;
	
}

public class MdlReqPackageMaster : MdlRequest {

	public MdlPackageMaster mdlPackageMaster { get; set; } = new MdlPackageMaster();
}

public class MdlResPackageMaster : MdlResponse {

	public MdlPackageMaster mdlPackageMaster { get; set; } = new MdlPackageMaster();
}

public class MdlResPackageMasterList : MdlResponse {

	public List<MdlPackageMaster> lstMdlPackageMaster { get; set; } = new List<MdlPackageMaster>();
}

public class MdlResPackageMasterInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlPackageCategoryBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlIncomeAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlControlAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlSupplierAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlSupplierSideControlAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlCommissionAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlServiceFeeAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlManagementFeeAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlPaybackAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlDiscountAcBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlPackageMaster> lstMdlPackageMaster { get; set; } = new List<MdlPackageMaster>();
}

