-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
-- @@@@@@@@@@  PACKAGE->TBL_PACKAGE_MASTER TBL_PACKAGE_MASTER TBL_PACKAGE_MASTER  @@@@@@@@@@
-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_package_master() RETURNS SETOF package.tbl_package_master AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT * FROM package.tbl_package_master WHERE int_sys_action_id != -1;  
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_package_master_with_action_user() 
                            RETURNS TABLE (pk_package_master_id BIGINT,

								fk_package_category_id BIGINT,
								fk_income_ac_id BIGINT,
								fk_control_ac_id BIGINT,

								vhr_package_code VARCHAR,
								vhr_package_name VARCHAR,
								sin_default SMALLINT,
								sin_own_package SMALLINT,
								vhr_erp_code VARCHAR,

								dat_issue_from DATE,
								dat_issue_to DATE,
								dat_service_from DATE,
								dat_service_to DATE,

								sin_allow_stock SMALLINT,
								sin_no_of_days SMALLINT,
								sin_no_of_pax SMALLINT,
								sin_adult SMALLINT,
								sin_child SMALLINT,
								sin_infant SMALLINT,

								arb_fk_branch_ids BIGINT[],
								arb_fk_service_ids BIGINT[],

								txt_remarks TEXT,

								sin_additional_item_in_invoice_print SMALLINT,
								sin_additional_item_details_in_file_open_print SMALLINT,
								sin_print_information_in_invoice_print SMALLINT,
								sin_print_information_details_in_file_open_print SMALLINT,

								fk_supplier_ac_id BIGINT,
								fk_supplier_side_control_ac_id BIGINT,
								fk_commission_ac_id BIGINT,
								fk_service_fee_ac_id BIGINT,
								fk_management_fee_ac_id BIGINT,
								fk_payback_ac_id BIGINT,
								fk_discount_ac_id BIGINT,

								vhr_base_currency VARCHAR,
								dbl_base_cur_fare DOUBLE PRECISION,
								dbl_base_cur_tax DOUBLE PRECISION,
								dbl_base_cur_comm_percentage DOUBLE PRECISION,
								dbl_base_cur_commission_amount DOUBLE PRECISION,
								dbl_base_cur_supplier_fee_perc DOUBLE PRECISION,
								dbl_base_cur_supplier_fee DOUBLE PRECISION,
								dbl_base_cur_supplier_amount DOUBLE PRECISION,
								dbl_base_cur_service_fee_perc DOUBLE PRECISION,
								dbl_base_cur_service_fee DOUBLE PRECISION,
								dbl_base_cur_management_fee_perc DOUBLE PRECISION,
								dbl_base_cur_management_fee DOUBLE PRECISION,
								dbl_base_cur_discount_perc DOUBLE PRECISION,
								dbl_base_cur_discount DOUBLE PRECISION,
								dbl_base_cur_cost DOUBLE PRECISION,
								dbl_base_cur_price DOUBLE PRECISION,

								vhr_sup_currency VARCHAR,
								dbl_sup_cur_roe DOUBLE PRECISION,
								dbl_sup_cur_fare DOUBLE PRECISION,
								dbl_sup_cur_tax DOUBLE PRECISION,
								dbl_sup_cur_comm_percentage DOUBLE PRECISION,
								dbl_sup_cur_commission_amount DOUBLE PRECISION,
								dbl_sup_cur_supplier_fee_perc DOUBLE PRECISION,
								dbl_sup_cur_supplier_fee DOUBLE PRECISION,
								dbl_sup_cur_supplier_amount DOUBLE PRECISION,
								dbl_sup_cur_service_fee_perc DOUBLE PRECISION,
								dbl_sup_cur_service_fee DOUBLE PRECISION,
								dbl_sup_cur_management_fee_perc DOUBLE PRECISION,
								dbl_sup_cur_management_fee DOUBLE PRECISION,
								dbl_sup_cur_discount_perc DOUBLE PRECISION,
								dbl_sup_cur_discount DOUBLE PRECISION,
								dbl_sup_cur_cost DOUBLE PRECISION,
								dbl_sup_cur_price DOUBLE PRECISION,

								jsn_batch_details JSON,

								sin_record_status SMALLINT,
								sin_order SMALLINT,


								int_sys_action_id INT,
								fk_created_user_id BIGINT,
								vhr_created_user VARCHAR,
								dtm_created TIMESTAMP WITH TIME ZONE,
								fk_last_modified_user_id BIGINT,
								vhr_last_modified_user VARCHAR,
								dtm_last_modified TIMESTAMP WITH TIME ZONE,
								fk_deleted_user_id BIGINT,
								vhr_deleted_user VARCHAR,
								dtm_deleted TIMESTAMP WITH TIME ZONE) AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT mt.pk_package_master_id,

					mt.fk_package_category_id,
					mt.fk_income_ac_id,
					mt.fk_control_ac_id,

					mt.vhr_package_code,
					mt.vhr_package_name,
					mt.sin_default,
					mt.sin_own_package,
					mt.vhr_erp_code,

					mt.dat_issue_from,
					mt.dat_issue_to,
					mt.dat_service_from,
					mt.dat_service_to,

					mt.sin_allow_stock,
					mt.sin_no_of_days,
					mt.sin_no_of_pax,
					mt.sin_adult,
					mt.sin_child,
					mt.sin_infant,

					mt.arb_fk_branch_ids,
					mt.arb_fk_service_ids,

					mt.txt_remarks,

					mt.sin_additional_item_in_invoice_print,
					mt.sin_additional_item_details_in_file_open_print,
					mt.sin_print_information_in_invoice_print,
					mt.sin_print_information_details_in_file_open_print,

					mt.fk_supplier_ac_id,
					mt.fk_supplier_side_control_ac_id,
					mt.fk_commission_ac_id,
					mt.fk_service_fee_ac_id,
					mt.fk_management_fee_ac_id,
					mt.fk_payback_ac_id,
					mt.fk_discount_ac_id,

					mt.vhr_base_currency,
					mt.dbl_base_cur_fare,
					mt.dbl_base_cur_tax,
					mt.dbl_base_cur_comm_percentage,
					mt.dbl_base_cur_commission_amount,
					mt.dbl_base_cur_supplier_fee_perc,
					mt.dbl_base_cur_supplier_fee,
					mt.dbl_base_cur_supplier_amount,
					mt.dbl_base_cur_service_fee_perc,
					mt.dbl_base_cur_service_fee,
					mt.dbl_base_cur_management_fee_perc,
					mt.dbl_base_cur_management_fee,
					mt.dbl_base_cur_discount_perc,
					mt.dbl_base_cur_discount,
					mt.dbl_base_cur_cost,
					mt.dbl_base_cur_price,

					mt.vhr_sup_currency,
					mt.dbl_sup_cur_roe,
					mt.dbl_sup_cur_fare,
					mt.dbl_sup_cur_tax,
					mt.dbl_sup_cur_comm_percentage,
					mt.dbl_sup_cur_commission_amount,
					mt.dbl_sup_cur_supplier_fee_perc,
					mt.dbl_sup_cur_supplier_fee,
					mt.dbl_sup_cur_supplier_amount,
					mt.dbl_sup_cur_service_fee_perc,
					mt.dbl_sup_cur_service_fee,
					mt.dbl_sup_cur_management_fee_perc,
					mt.dbl_sup_cur_management_fee,
					mt.dbl_sup_cur_discount_perc,
					mt.dbl_sup_cur_discount,
					mt.dbl_sup_cur_cost,
					mt.dbl_sup_cur_price,

					mt.jsn_batch_details,

					mt.sin_record_status,
					mt.sin_order,


					mt.int_sys_action_id,
					mt.fk_created_user_id,
					u1.vhr_login_name AS vhr_created_user,
					mt.dtm_created,
					mt.fk_last_modified_user_id,
					u2.vhr_login_name AS vhr_last_modified_user,
					mt.dtm_last_modified,
					mt.fk_deleted_user_id,
					u3.vhr_login_name AS vhr_deleted_user,
					mt.dtm_deleted
                        FROM package.tbl_package_master mt 
                            LEFT JOIN authentication.tbl_user u1
                                ON mt.fk_created_user_id =  u1.pk_user_id
                            LEFT JOIN authentication.tbl_user u2
                                ON mt.fk_last_modified_user_id =  u2.pk_user_id
                            LEFT JOIN authentication.tbl_user u3
                                ON mt.fk_deleted_user_id =  u3.pk_user_id
                        WHERE mt.int_sys_action_id != -1  
                        ORDER BY sin_order, vhr_package_name;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_insert_or_update_package_master(jsnPackageMaster JSONB, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // Duplication Checking in DB FUCTION(Insert and Update)
                    SELECT * FROM  fn_check_data_uniqueness('package.tbl_package_master'::VARCHAR, 'vhr_package_code'::VARCHAR, jsnPackageMaster->>'strPackageCode'::VARCHAR, 'pk_package_master_id'::VARCHAR, CAST(jsnPackageMaster->>'binPackageMasterId' AS BIGINT)::BIGINT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    IF CAST(jsnPackageMaster->>'binPackageMasterId' AS BIGINT)::BIGINT = 0::BIGINT THEN
                        -- // Count Exced or other checking License related in DB FUCTION(Insert)
                        

                        --jsnPackageMaster.intSysActionId = 0;
                        --jsnPackageMaster.binCreatedUserId = jsnPackageMaster.linLoginUserId;
                        --jsnPackageMaster.dtmCreated = jsnPackageMaster.dtmCurrentDateTime; --SELECT NOW();

                        INSERT INTO package.tbl_package_master (fk_package_category_id,
						fk_income_ac_id,
						fk_control_ac_id,

						vhr_package_code,
						vhr_package_name,
						sin_default,
						sin_own_package,
						vhr_erp_code,

						dat_issue_from,
						dat_issue_to,
						dat_service_from,
						dat_service_to,

						sin_allow_stock,
						sin_no_of_days,
						sin_no_of_pax,
						sin_adult,
						sin_child,
						sin_infant,

						arb_fk_branch_ids,
						arb_fk_service_ids,

						txt_remarks,

						sin_additional_item_in_invoice_print,
						sin_additional_item_details_in_file_open_print,
						sin_print_information_in_invoice_print,
						sin_print_information_details_in_file_open_print,

						fk_supplier_ac_id,
						fk_supplier_side_control_ac_id,
						fk_commission_ac_id,
						fk_service_fee_ac_id,
						fk_management_fee_ac_id,
						fk_payback_ac_id,
						fk_discount_ac_id,

						vhr_base_currency,
						dbl_base_cur_fare,
						dbl_base_cur_tax,
						dbl_base_cur_comm_percentage,
						dbl_base_cur_commission_amount,
						dbl_base_cur_supplier_fee_perc,
						dbl_base_cur_supplier_fee,
						dbl_base_cur_supplier_amount,
						dbl_base_cur_service_fee_perc,
						dbl_base_cur_service_fee,
						dbl_base_cur_management_fee_perc,
						dbl_base_cur_management_fee,
						dbl_base_cur_discount_perc,
						dbl_base_cur_discount,
						dbl_base_cur_cost,
						dbl_base_cur_price,

						vhr_sup_currency,
						dbl_sup_cur_roe,
						dbl_sup_cur_fare,
						dbl_sup_cur_tax,
						dbl_sup_cur_comm_percentage,
						dbl_sup_cur_commission_amount,
						dbl_sup_cur_supplier_fee_perc,
						dbl_sup_cur_supplier_fee,
						dbl_sup_cur_supplier_amount,
						dbl_sup_cur_service_fee_perc,
						dbl_sup_cur_service_fee,
						dbl_sup_cur_management_fee_perc,
						dbl_sup_cur_management_fee,
						dbl_sup_cur_discount_perc,
						dbl_sup_cur_discount,
						dbl_sup_cur_cost,
						dbl_sup_cur_price,

						jsn_batch_details,

						sin_record_status,
						sin_order,


						int_sys_action_id,
						fk_created_user_id,
						dtm_created)
                            VALUES(CAST(jsnPackageMaster->>'binPackageCategoryId' AS BIGINT),
						CAST(jsnPackageMaster->>'binIncomeAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binControlAcId' AS BIGINT),

						jsnPackageMaster->>'strPackageCode',
						jsnPackageMaster->>'strPackageName',
						CAST(jsnPackageMaster->>'sinDefault' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinOwnPackage' AS SMALLINT),
						jsnPackageMaster->>'strErpCode',

						CAST(jsnPackageMaster->>'datIssueFrom' AS DATE),
						CAST(jsnPackageMaster->>'datIssueTo' AS DATE),
						CAST(jsnPackageMaster->>'datServiceFrom' AS DATE),
						CAST(jsnPackageMaster->>'datServiceTo' AS DATE),

						CAST(jsnPackageMaster->>'sinAllowStock' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinNoOfDays' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinNoOfPax' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinAdult' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinChild' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinInfant' AS SMALLINT),

						STRING_TO_ARRAY(jsnPackageMaster->>'strDbArlFkBranchIds', ',')::BIGINT[],
						STRING_TO_ARRAY(jsnPackageMaster->>'strDbArlFkServiceIds', ',')::BIGINT[],

						CAST(jsnPackageMaster->>'strRemarks' AS TEXT),

						CAST(jsnPackageMaster->>'sinAdditionalItemInInvoicePrint' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinAdditionalItemDetailsInFileOpenPrint' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinPrintInformationInInvoicePrint' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinPrintInformationDetailsInFileOpenPrint' AS SMALLINT),

						CAST(jsnPackageMaster->>'binSupplierAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binSupplierSideControlAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binCommissionAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binServiceFeeAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binManagementFeeAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binPaybackAcId' AS BIGINT),
						CAST(jsnPackageMaster->>'binDiscountAcId' AS BIGINT),

						jsnPackageMaster->>'strBaseCurrency',
						CAST(jsnPackageMaster->>'dblBaseCurFare' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurTax' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurCommPercentage' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurCommissionAmount' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurSupplierFeePerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurSupplierFee' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurSupplierAmount' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurServiceFeePerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurServiceFee' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurManagementFeePerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurManagementFee' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurDiscountPerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurDiscount' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurCost' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblBaseCurPrice' AS DOUBLE PRECISION),

						jsnPackageMaster->>'strSupCurrency',
						CAST(jsnPackageMaster->>'dblSupCurRoe' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurFare' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurTax' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurCommPercentage' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurCommissionAmount' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurSupplierFeePerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurSupplierFee' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurSupplierAmount' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurServiceFeePerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurServiceFee' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurManagementFeePerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurManagementFee' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurDiscountPerc' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurDiscount' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurCost' AS DOUBLE PRECISION),
						CAST(jsnPackageMaster->>'dblSupCurPrice' AS DOUBLE PRECISION),

						CAST(jsnPackageMaster->>'jsnBatchDetails' AS JSON),

						CAST(jsnPackageMaster->>'sinRecordStatus' AS SMALLINT),
						CAST(jsnPackageMaster->>'sinOrder' AS SMALLINT),


						0,
						CAST(jsnPackageMaster->>'binCreatedUserId' AS BIGINT),
						dtmCurrent) RETURNING pk_package_master_id INTO objSpOutRes.binSqlPk;
                    ELSE
                        -- // UPDATE Check already update another usersin DB FUCTION(Update and Delete)
                        SELECT * FROM  fn_check_already_update_or_delete_another_user('package.tbl_package_master'::VARCHAR, 'pk_package_master_id'::VARCHAR, CAST(jsnPackageMaster->>'binPackageMasterId' AS BIGINT)::BIGINT, CAST(jsnPackageMaster->>'intSysActionId' AS INT)::INT) INTO objFnCheckRes;
                        IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                            objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                            objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                            objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                            objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                            SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                            RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                            RETURN;
                        END IF;

                        --jsnPackageMaster.intSysActionId = jsnPackageMaster.intSysActionId + 1;
                        --jsnPackageMaster.binLastModifiedUserId = jsnPackageMaster.linLoginUserId;
                        --jsnPackageMaster.dtmLastModified = jsnPackageMaster.dtmCurrentDateTime; --SELECT NOW();

                        UPDATE package.tbl_package_master SET fk_package_category_id = CAST(jsnPackageMaster->>'binPackageCategoryId' AS BIGINT),
						fk_income_ac_id = CAST(jsnPackageMaster->>'binIncomeAcId' AS BIGINT),
						fk_control_ac_id = CAST(jsnPackageMaster->>'binControlAcId' AS BIGINT),

						vhr_package_code = jsnPackageMaster->>'strPackageCode',
						vhr_package_name = jsnPackageMaster->>'strPackageName',
						sin_default = CAST(jsnPackageMaster->>'sinDefault' AS SMALLINT),
						sin_own_package = CAST(jsnPackageMaster->>'sinOwnPackage' AS SMALLINT),
						vhr_erp_code = jsnPackageMaster->>'strErpCode',

						dat_issue_from = CAST(jsnPackageMaster->>'datIssueFrom' AS DATE),
						dat_issue_to = CAST(jsnPackageMaster->>'datIssueTo' AS DATE),
						dat_service_from = CAST(jsnPackageMaster->>'datServiceFrom' AS DATE),
						dat_service_to = CAST(jsnPackageMaster->>'datServiceTo' AS DATE),

						sin_allow_stock = CAST(jsnPackageMaster->>'sinAllowStock' AS SMALLINT),
						sin_no_of_days = CAST(jsnPackageMaster->>'sinNoOfDays' AS SMALLINT),
						sin_no_of_pax = CAST(jsnPackageMaster->>'sinNoOfPax' AS SMALLINT),
						sin_adult = CAST(jsnPackageMaster->>'sinAdult' AS SMALLINT),
						sin_child = CAST(jsnPackageMaster->>'sinChild' AS SMALLINT),
						sin_infant = CAST(jsnPackageMaster->>'sinInfant' AS SMALLINT),

						arb_fk_branch_ids = STRING_TO_ARRAY(jsnPackageMaster->>'strDbArlFkBranchIds', ',')::BIGINT[],
						arb_fk_service_ids = STRING_TO_ARRAY(jsnPackageMaster->>'strDbArlFkServiceIds', ',')::BIGINT[],

						txt_remarks = jsnPackageMaster->>'strRemarks',

						sin_additional_item_in_invoice_print = CAST(jsnPackageMaster->>'sinAdditionalItemInInvoicePrint' AS SMALLINT),
						sin_additional_item_details_in_file_open_print = CAST(jsnPackageMaster->>'sinAdditionalItemDetailsInFileOpenPrint' AS SMALLINT),
						sin_print_information_in_invoice_print = CAST(jsnPackageMaster->>'sinPrintInformationInInvoicePrint' AS SMALLINT),
						sin_print_information_details_in_file_open_print = CAST(jsnPackageMaster->>'sinPrintInformationDetailsInFileOpenPrint' AS SMALLINT),

						fk_supplier_ac_id = CAST(jsnPackageMaster->>'binSupplierAcId' AS BIGINT),
						fk_supplier_side_control_ac_id = CAST(jsnPackageMaster->>'binSupplierSideControlAcId' AS BIGINT),
						fk_commission_ac_id = CAST(jsnPackageMaster->>'binCommissionAcId' AS BIGINT),
						fk_service_fee_ac_id = CAST(jsnPackageMaster->>'binServiceFeeAcId' AS BIGINT),
						fk_management_fee_ac_id = CAST(jsnPackageMaster->>'binManagementFeeAcId' AS BIGINT),
						fk_payback_ac_id = CAST(jsnPackageMaster->>'binPaybackAcId' AS BIGINT),
						fk_discount_ac_id = CAST(jsnPackageMaster->>'binDiscountAcId' AS BIGINT),

						vhr_base_currency = jsnPackageMaster->>'strBaseCurrency',
						dbl_base_cur_fare = CAST(jsnPackageMaster->>'dblBaseCurFare' AS DOUBLE PRECISION),
						dbl_base_cur_tax = CAST(jsnPackageMaster->>'dblBaseCurTax' AS DOUBLE PRECISION),
						dbl_base_cur_comm_percentage = CAST(jsnPackageMaster->>'dblBaseCurCommPercentage' AS DOUBLE PRECISION),
						dbl_base_cur_commission_amount = CAST(jsnPackageMaster->>'dblBaseCurCommissionAmount' AS DOUBLE PRECISION),
						dbl_base_cur_supplier_fee_perc = CAST(jsnPackageMaster->>'dblBaseCurSupplierFeePerc' AS DOUBLE PRECISION),
						dbl_base_cur_supplier_fee = CAST(jsnPackageMaster->>'dblBaseCurSupplierFee' AS DOUBLE PRECISION),
						dbl_base_cur_supplier_amount = CAST(jsnPackageMaster->>'dblBaseCurSupplierAmount' AS DOUBLE PRECISION),
						dbl_base_cur_service_fee_perc = CAST(jsnPackageMaster->>'dblBaseCurServiceFeePerc' AS DOUBLE PRECISION),
						dbl_base_cur_service_fee = CAST(jsnPackageMaster->>'dblBaseCurServiceFee' AS DOUBLE PRECISION),
						dbl_base_cur_management_fee_perc = CAST(jsnPackageMaster->>'dblBaseCurManagementFeePerc' AS DOUBLE PRECISION),
						dbl_base_cur_management_fee = CAST(jsnPackageMaster->>'dblBaseCurManagementFee' AS DOUBLE PRECISION),
						dbl_base_cur_discount_perc = CAST(jsnPackageMaster->>'dblBaseCurDiscountPerc' AS DOUBLE PRECISION),
						dbl_base_cur_discount = CAST(jsnPackageMaster->>'dblBaseCurDiscount' AS DOUBLE PRECISION),
						dbl_base_cur_cost = CAST(jsnPackageMaster->>'dblBaseCurCost' AS DOUBLE PRECISION),
						dbl_base_cur_price = CAST(jsnPackageMaster->>'dblBaseCurPrice' AS DOUBLE PRECISION),

						vhr_sup_currency = jsnPackageMaster->>'strSupCurrency',
						dbl_sup_cur_roe = CAST(jsnPackageMaster->>'dblSupCurRoe' AS DOUBLE PRECISION),
						dbl_sup_cur_fare = CAST(jsnPackageMaster->>'dblSupCurFare' AS DOUBLE PRECISION),
						dbl_sup_cur_tax = CAST(jsnPackageMaster->>'dblSupCurTax' AS DOUBLE PRECISION),
						dbl_sup_cur_comm_percentage = CAST(jsnPackageMaster->>'dblSupCurCommPercentage' AS DOUBLE PRECISION),
						dbl_sup_cur_commission_amount = CAST(jsnPackageMaster->>'dblSupCurCommissionAmount' AS DOUBLE PRECISION),
						dbl_sup_cur_supplier_fee_perc = CAST(jsnPackageMaster->>'dblSupCurSupplierFeePerc' AS DOUBLE PRECISION),
						dbl_sup_cur_supplier_fee = CAST(jsnPackageMaster->>'dblSupCurSupplierFee' AS DOUBLE PRECISION),
						dbl_sup_cur_supplier_amount = CAST(jsnPackageMaster->>'dblSupCurSupplierAmount' AS DOUBLE PRECISION),
						dbl_sup_cur_service_fee_perc = CAST(jsnPackageMaster->>'dblSupCurServiceFeePerc' AS DOUBLE PRECISION),
						dbl_sup_cur_service_fee = CAST(jsnPackageMaster->>'dblSupCurServiceFee' AS DOUBLE PRECISION),
						dbl_sup_cur_management_fee_perc = CAST(jsnPackageMaster->>'dblSupCurManagementFeePerc' AS DOUBLE PRECISION),
						dbl_sup_cur_management_fee = CAST(jsnPackageMaster->>'dblSupCurManagementFee' AS DOUBLE PRECISION),
						dbl_sup_cur_discount_perc = CAST(jsnPackageMaster->>'dblSupCurDiscountPerc' AS DOUBLE PRECISION),
						dbl_sup_cur_discount = CAST(jsnPackageMaster->>'dblSupCurDiscount' AS DOUBLE PRECISION),
						dbl_sup_cur_cost = CAST(jsnPackageMaster->>'dblSupCurCost' AS DOUBLE PRECISION),
						dbl_sup_cur_price = CAST(jsnPackageMaster->>'dblSupCurPrice' AS DOUBLE PRECISION),

						jsn_batch_details = CAST(jsnPackageMaster->>'jsnBatchDetails' AS JSON),

						sin_record_status = CAST(jsnPackageMaster->>'sinRecordStatus' AS SMALLINT),
						sin_order = CAST(jsnPackageMaster->>'sinOrder' AS SMALLINT),


						int_sys_action_id = int_sys_action_id + 1,
						fk_last_modified_user_id = CAST(jsnPackageMaster->>'binLastModifiedUserId' AS BIGINT),
						dtm_last_modified = dtmCurrent 
                        WHERE pk_package_master_id = CAST(jsnPackageMaster->>'binPackageMasterId' AS BIGINT);
                    END IF;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'PackageMaster Saved';
                    objSpOutRes.dtmCurrent = dtmCurrent;
                    
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'PackageMaster Save Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;
                
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_delete_package_master(binPackageMasterId BIGINT, intSysActionId INT, binDeletedUserId BIGINT, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // FOREIGN KEY REFERENCES Checking in DB FUCTION(Delete)
                    SELECT * FROM  fn_check_foreignkey_referance('tbl_package_master'::VARCHAR, 'pk_package_master_id'::VARCHAR, binPackageMasterId::BIGINT, '{}'::VARCHAR ARRAY) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    -- // UPDATE Check already update another users in DB FUCTION(Update and Delete)
                    SELECT * FROM  fn_check_already_update_or_delete_another_user('package.tbl_package_master'::VARCHAR, 'pk_package_master_id'::VARCHAR, CAST(binPackageMasterId AS BIGINT)::BIGINT, intSysActionId::INT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    --dtmDeleted = SELECT NOW();
                    UPDATE package.tbl_package_master SET int_sys_action_id = -1::INT,
                                fk_deleted_user_id = binDeletedUserId,
                                dtm_deleted = dtmCurrent
                        WHERE pk_package_master_id = binPackageMasterId;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'PackageMaster Deleted';
                    objSpOutRes.dtmCurrent = dtmCurrent;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'PackageMaster Delete Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

